#include <dos.h>
#include <conio.h>
#include "move.h"

#define KEY1    71
#define KEY2    72
#define KEY3    73
#define KEY4    75
#define KEY5    77
#define KEY6    80
#define KEY7    74
#define KEY8    78
#define KEY9     1
#define KEY10   42
#define KEY11   58
#define KEY12   82
#define KEY13   79
#define KEY14   76

#define STEP     5

typedef unsigned short word;

long kbdword;

void (interrupt far *oldint9)(void);

void keyboard_lock_region_begin( void )
{
}

void _loadds interrupt kbdhandler( void )
{
  char p;
  long bx;

  p=(char)inp(0x60);
  bx=0;
  switch (p&127) {
    case KEY1 : bx=1;break;
    case KEY2 : bx=2;break;
    case KEY3 : bx=4;break;
    case KEY4 : bx=8;break;
    case KEY5 : bx=16;break;
    case KEY6 : bx=32;break;
    case KEY7 : bx=64;break;
    case KEY8 : bx=128;break;
    case KEY9 : bx=256;break;
    case KEY10: bx=512;break;
    case KEY11: bx=1024;break;
    case KEY12: bx=2048;break;
    case KEY13: bx=4096;break;
    case KEY14: bx=8192;break;
  }
  if (p&128) kbdword&=~bx;
        else kbdword|=bx;
  outp(0x20,0x20);
}

//Dummy function to indicate org of the code to lock
void keyboard_lock_region_end( void )
{
}

int lock_region ( void *address, unsigned length )
{
  union REGS regs;
  unsigned linear;

  /* Thanks to DOS/4GW's zero-based flat memory model, converting
     a pointer of any type to a linear address is trivial.
  */
  linear = (unsigned) address;

  regs.w.ax = 0x600;                      /* DPMI Lock Linear Region */
  regs.w.bx = (word) ( linear >> 16 );    /* Linear address in BX:CX */
  regs.w.cx = (word) ( linear & 0xFFFF );
  regs.w.si = (word) ( length >> 16 );    /* Length in SI:DI */
  regs.w.di = (word) ( length & 0xFFFF );
  int386 (0x31, &regs, &regs);
  return !regs.w.cflag;                   /* Return 0 if can't lock */
}

void hookkbd( void )
{
  lock_region( (void near *) keyboard_lock_region_begin,
                 (char *) keyboard_lock_region_end -
                 (char *) keyboard_lock_region_begin );
  kbdword=0;
  oldint9=_dos_getvect(9);
  _dos_setvect(9,kbdhandler);
}

void koohkbd( void )
{
  _dos_setvect(9,oldint9);
}

int move( void )
{
  int dx,dy,step;

  dx=0;dy=0;
  step=(kbdword&1024)?1:STEP;
  if (kbdword&512) step*=2;
  if (kbdword&  1) dx=step;
  if (kbdword&  2) dy=step;
  if (kbdword&  4) dx=-step;
  if (kbdword&  8) vd=(vd-((kbdword&512)?2:1))&(MAXVD-1);
  if (kbdword& 16) vd=(vd+((kbdword&512)?2:1))&(MAXVD-1);
  if (kbdword& 32) dy=-step;
  if (kbdword& 64) vz0+=step;
  if (kbdword&128) vz0-=step;
  if (kbdword&2048) vh-=2;
  if (kbdword&4096) vh+=2;
  if (kbdword&8192) vh=0;
  if (kbdword&256) return 0;

  vy+=dy*costbl[vd]+dx*sintbl[vd];
  vx+=dy*sintbl[vd]-dx*costbl[vd];
  if (kbdword&(1+2+4+32)) {
    vdz=(vdz+step/STEP)%20;
    guni=(guni+2)&(MAXVD-1);
  }
  if (vdz<10) vz=vz0+vdz;
         else vz=vz0+20-vdz;
  return 1;
}
