                .486
                .model  flat

                public  drawver,drawhor,drawwall,drawcf,drawgunv

                .code
                extrn   table320:dword,buffer:dword,scr_cols:dword

; edx - x
; ebx - y
; ecx - len
; al  - color

drawver         proc
                mov     ebx,table320[ebx*4]
                add     ebx,buffer
                add     ebx,edx
dvl1:           mov     [ebx],al
                add     ebx,scr_cols
                dec     ecx
                jg      dvl1
                ret
                endp

drawhor         proc
                mov     ebx,table320[ebx*4]
                add     ebx,buffer
                add     ebx,edx
dhl1:           mov     [ebx],al
                inc     ebx
                dec     ecx
                jg      dhl1
                ret
                endp


; ebx - address
; edi - len
; eax - texture
; ecx - step
; esi - begin
; eax - pal

drawwall        proc
                push    ebp
                mov     ebp,edx
                mov     len,edi
                xor     edi,edi
                shld    edi,esi,16
                shl     esi,16
                xor     edx,edx
                shld    edx,ecx,16
                shl     ecx,16
dwl1:
                and     edi,127
                mov     al,[ebp+edi]
                mov     al,[eax]
                mov     [ebx],al
                add     ebx,scr_cols
                add     esi,ecx
                adc     edi,edx
                dec     len
                jg      dwl1
                pop     ebp
                ret
                endp

; ebx - address
; ecx - len
; esi - texture
; edx - step
; edi - begin
; eax - pal

drawcf          proc
                push    ebp
                mov     ebp,edx
dcl1:
                shld    edx,edi,22
                shld    edx,edi,6
                and     edx,111111111111b
                mov     al,[esi+edx]
                mov     al,[eax]
                mov     [ebx],al
                add     edi,ebp
                inc     ebx
                dec     ecx
                jg      dcl1
                pop     ebp
                ret
                endp

; ebx - address
; esi - gun
; ecx - len

drawgunv        proc
dgl1:
                mov     al,[esi]
                cmp     al,255
                je      dgc1
                mov     [ebx],al
dgc1:
                add     ebx,scr_cols
                inc     esi
                dec     ecx
                jg      dgl1
                ret
                endp

                .data

len             dd      ?

                end
