#ifndef _READ_H
#define _READ_H

#define MAXWALL 3000

#define GUNX 79
#define GUNY 60

struct Twall {
  int x1,y1,x2,y2;
  int l,r;
  int h1,h2,h3,h4;
  char xo,yo;
  char txw,txff,txfc,txbf,txbc;
  int len;
};

#ifdef MAIN_DATA
  Twall tree[MAXWALL];
  int wall_num;

  char *txwalls[10];
  char *txfloors[10];
  char gunbmp[GUNX][GUNY];
#else
  extern Twall tree[MAXWALL];
  extern int wall_num;

  extern char *txwalls[10];
  extern char *txfloors[10];
  extern char gunbmp[GUNX][GUNY];
#endif

int readmap(char *name);
void freemap( void );

#endif
